﻿Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports System.Text
Imports System.Windows
Imports System.Windows.Controls
Imports System.Windows.Data
Imports System.Windows.Documents
Imports System.Windows.Input
Imports System.Windows.Media
Imports System.Windows.Media.Imaging
Imports System.Windows.Navigation
Imports System.Windows.Shapes
Imports System.Data.Sql


Partial Public Class MainForm
    Inherits Window

    Public Shared m_objMainForm As MainForm = Nothing
    Private m_objVaxUserAgent As cVaxSIPUserAgentExCOM

    Private m_objAccountForm As AccountForm = Nothing
    Private m_objPhoneForm As PhoneForm = Nothing
    Private m_objVideoForm As VideoForm = Nothing
    Private m_objChatForm As ChatForm = Nothing
    Private m_objBusyLampForm As MainBusyLampForm = Nothing
    Private m_objSettingForm As SettingForm = Nothing
    Private m_objAccountRecForm As AccountRecForm = Nothing

    Public Sub New()

        m_objVaxUserAgent = New cVaxSIPUserAgentExCOM()

        InitializeComponent()
        m_objMainForm = Me

        m_objAccountForm = AccountForm.GetOBJ()
        m_objPhoneForm = PhoneForm.GetOBJ()
        m_objVideoForm = VideoForm.GetOBJ()
        m_objChatForm = ChatForm.GetOBJ()
        m_objBusyLampForm = MainBusyLampForm.GetOBJ()
        m_objSettingForm = SettingForm.GetOBJ()
        m_objAccountRecForm = AccountRecForm.GetOBJ()

    End Sub

    Public Function GetActiveTab() As Integer
        Return TabControlMain.SelectedIndex
    End Function

    Public Sub SetActiveTab(ByVal nTab As Integer)
        TabControlMain.SelectedIndex = nTab
    End Sub

    '/////////////////////////////////////////////////////////////////////////
    '/////////////////////////////////////////////////////////////////////////

    Public Sub OnVaxOnline()

        m_objPhoneForm.OnVaxOnline()
        m_objChatForm.OnVaxOnline()
        m_objBusyLampForm.OnVaxOnline()
        m_objSettingForm.OnVaxOnline()
        m_objVideoForm.OnVaxOnline()

    End Sub

    Public Sub OnVaxOffline()

        m_objPhoneForm.OnVaxOffline()
        m_objChatForm.OnVaxOffline()
        m_objBusyLampForm.OnVaxOffline()
        m_objVideoForm.OnVaxOffline()

    End Sub

    '/////////////////////////////////////////////////////////////////////////
    '/////////////////////////////////////////////////////////////////////////

    Public Sub OnConnectingToRegister()
        m_objAccountForm.OnConnectingToRegister()
    End Sub

    Public Sub OnTryingToRegister()
        m_objAccountForm.OnTryingToRegister()
    End Sub

    Public Sub OnFailToRegister(ByVal nStatusCode As Integer, ByVal sReasonPhrase As String)
        m_objAccountForm.OnFailToRegister(nStatusCode, sReasonPhrase)
    End Sub

    Public Sub OnSuccessToRegister()
        m_objAccountForm.OnSuccessToRegister()
    End Sub

    '/////////////////////////////////////////////////////////////////////////
    '/////////////////////////////////////////////////////////////////////////

    Public Sub OnConnectingToReRegister()
        m_objAccountForm.OnConnectingToReRegister()
    End Sub

    Public Sub OnTryingToReRegister()
        m_objAccountForm.OnTryingToReRegister()
    End Sub

    Public Sub OnFailToReRegister(ByVal nStatusCode As Integer, ByVal sReasonPhrase As String)
        m_objAccountForm.OnFailToReRegister(nStatusCode, sReasonPhrase)
    End Sub

    Public Sub OnSuccessToReRegister()
        m_objAccountForm.OnSuccessToReRegister()
    End Sub

    Public Sub OnTryingToUnRegister()
        m_objAccountForm.OnTryingToUnRegister()
    End Sub

    Public Sub OnFailToUnRegister()
        m_objAccountForm.OnFailToUnRegister()
    End Sub

    Public Sub OnSuccessToUnRegister()
        m_objAccountForm.OnSuccessToUnRegister()
    End Sub

    '/////////////////////////////////////////////////////////////////////////
    '/////////////////////////////////////////////////////////////////////////

    Public Sub OnTransferCallFailed(ByVal nLineNo As Integer, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String)
        m_objPhoneForm.OnTransferCallFailed(nLineNo, nStatusCode, sReasonPhrase)
    End Sub

    Public Sub OnDigitDTMF(ByVal nLineNo As Integer, ByVal sDigit As String)
        m_objPhoneForm.OnDigitDTMF(nLineNo, sDigit)
    End Sub

    Public Sub OnPlayWaveDone(ByVal nLineNo As Integer)
        m_objPhoneForm.OnPlayWaveDone(nLineNo)
    End Sub

    '/////////////////////////////////////////////////////////////////////////
    '/////////////////////////////////////////////////////////////////////////

    Public Sub OnIncomingCallStarted(ByVal sCallId As String, ByVal sCallerName As String, ByVal sCallerId As String)
        m_objPhoneForm.OnIncomingCallStarted(sCallId, sCallerName, sCallerId)
    End Sub

    Public Sub OnIncomingCallEnded(ByVal sCallId As String)
        m_objPhoneForm.OnIncomingCallEnded(sCallId)
    End Sub

    Public Sub OnRingToneStarted(ByVal sCallId As String)
        m_objPhoneForm.OnRingToneStarted(sCallId)
    End Sub

    Public Sub OnRingToneEnded(ByVal sCallId As String)
        m_objPhoneForm.OnRingToneEnded(sCallId)
    End Sub

    '/////////////////////////////////////////////////////////////////////////
    '/////////////////////////////////////////////////////////////////////////

    Public Sub OnTransferCallAccepted(ByVal nLineNo As Integer)
        m_objPhoneForm.OnTransferCallAccepted(nLineNo)
    End Sub

    Public Sub OnHungupCall(ByVal nLineNo As Integer)
        m_objPhoneForm.OnHungupCall(nLineNo)
    End Sub

    '/////////////////////////////////////////////////////////////////////////
    '/////////////////////////////////////////////////////////////////////////

    Public Sub OnVoiceMailMsg(ByVal bIsMsgWaiting As Boolean, ByVal nNewMsgCount As Integer, ByVal nOldMsgCount As Integer, ByVal nNewUrgentMsgCount As Integer, ByVal nOldUrgentMsgCount As Integer, ByVal sMsgAccount As String)
        m_objAccountForm.OnVoiceMailMsg(bIsMsgWaiting, nNewMsgCount, nOldMsgCount, nNewUrgentMsgCount, nOldUrgentMsgCount, sMsgAccount)
    End Sub

    '/////////////////////////////////////////////////////////////////////////
    '/////////////////////////////////////////////////////////////////////////

    Public Sub OnDialCallStarted(ByVal nLineNo As Integer, ByVal sCallerName As String, ByVal sCallerId As String, ByVal sDialNo As String)
        m_objPhoneForm.OnDialCallStarted(nLineNo, sCallerName, sCallerId, sDialNo)
    End Sub

    Public Sub OnDialingCall(ByVal nLineNo As Integer, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String)
        m_objPhoneForm.OnDialingCall(nLineNo, nStatusCode, sReasonPhrase)
    End Sub

    Public Sub OnDialCallFailed(ByVal nLineNo As Integer, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String, ByVal sContact As String)
        m_objPhoneForm.OnDialCallFailed(nLineNo, nStatusCode, sReasonPhrase, sContact)
    End Sub

    Public Sub OnConnectedCall(ByVal nLineNo As Integer)
        m_objPhoneForm.OnConnectedCall(nLineNo)
    End Sub

    '/////////////////////////////////////////////////////////////////////////
    '/////////////////////////////////////////////////////////////////////////

    Public Sub OnSuccessToHold(ByVal nLineNo As Integer)
        m_objPhoneForm.OnSuccessToHold(nLineNo)
    End Sub

    Public Sub OnTryingToHold(ByVal nLineNo As Integer)
        m_objPhoneForm.OnTryingToHold(nLineNo)
    End Sub

    Public Sub OnFailToHold(ByVal nLineNo As Integer)
        m_objPhoneForm.OnFailToHold(nLineNo)
    End Sub

    '/////////////////////////////////////////////////////////////////////////
    '/////////////////////////////////////////////////////////////////////////

    Public Sub OnSuccessToUnHold(ByVal nLineNo As Integer)
        m_objPhoneForm.OnSuccessToUnHold(nLineNo)
    End Sub

    Public Sub OnTryingToUnHold(ByVal nLineNo As Integer)
        m_objPhoneForm.OnTryingToUnHold(nLineNo)
    End Sub

    Public Sub OnFailToUnHold(ByVal nLineNo As Integer)
        m_objPhoneForm.OnFailToUnHold(nLineNo)
    End Sub

    '/////////////////////////////////////////////////////////////////////////
    '/////////////////////////////////////////////////////////////////////////

    Public Sub OnDetectedAMD(ByVal nLineNo As Integer, ByVal bIsHuman As Boolean)
        m_objPhoneForm.OnDetectedAMD(nLineNo, bIsHuman)
    End Sub

    '/////////////////////////////////////////////////////////////////////////
    '/////////////////////////////////////////////////////////////////////////

    Public Sub OnBusyLampSubscribeSuccess(ByVal sUserName As String)
        m_objBusyLampForm.OnBusyLampSubscribeSuccess(sUserName)
    End Sub

    Public Sub OnBusyLampSubscribeFailed(ByVal sUserName As String, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String)
        m_objBusyLampForm.OnBusyLampSubscribeFailed(sUserName, nStatusCode, sReasonPhrase)
    End Sub

    Public Sub OnBusyLampContactStatus(ByVal sUserName As String, ByVal nStatusId As Integer)
        m_objBusyLampForm.OnBusyLampContactStatus(sUserName, nStatusId)
    End Sub

    '/////////////////////////////////////////////////////////////////////////
    '/////////////////////////////////////////////////////////////////////////

    Public Sub OnChatSubscribeSuccess(ByVal sUserName As String)
        m_objChatForm.OnChatSubscribeSuccess(sUserName)
    End Sub

    Public Sub OnChatSubscribeFailed(ByVal sUserName As String, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String)
        m_objChatForm.OnChatSubscribeFailed(sUserName, nStatusCode, sReasonPhrase)
    End Sub

    Public Sub OnChatContactStatus(ByVal sUserName As String, ByVal nStatusId As Integer)
        m_objChatForm.OnChatContactStatus(sUserName, nStatusId)
    End Sub

    Public Sub OnChatSendMsgTextSuccess(ByVal sUserName As String, ByVal sMsgText As String, ByVal nUserValue As Long)
        m_objChatForm.OnChatSendMsgTextSuccess(sUserName, sMsgText, nUserValue)
    End Sub

    Public Sub OnChatSendMsgTextFailed(ByVal sUserName As String, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String, ByVal sMsgText As String, ByVal nUserValue As Long)
        m_objChatForm.OnChatSendMsgTextFailed(sUserName, nStatusCode, sReasonPhrase, sMsgText, nUserValue)
    End Sub

    Public Sub OnChatSendMsgTypingSuccess(ByVal sUserName As String, ByVal nUserValue As Long)
        m_objChatForm.OnChatSendMsgTypingSuccess(sUserName, nUserValue)
    End Sub

    Public Sub OnChatSendMsgTypingFailed(ByVal sUserName As String, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String, ByVal nUserValue As Long)
        m_objChatForm.OnChatSendMsgTypingFailed(sUserName, nStatusCode, sReasonPhrase, nUserValue)
    End Sub

    Public Sub OnChatRecvMsgText(ByVal sUserName As String, ByVal sMsgText As String, ByVal bIsChatContact As Boolean)
        m_objChatForm.OnChatRecvMsgText(sUserName, sMsgText, bIsChatContact)
    End Sub

    Public Sub OnChatRecvMsgTypingStart(ByVal sUserName As String)
        m_objChatForm.OnChatRecvMsgTypingStart(sUserName)
    End Sub

    Public Sub OnChatRecvMsgTypingStop(ByVal sUserName As String)
        m_objChatForm.OnChatRecvMsgTypingStop()
    End Sub

    '/////////////////////////////////////////////////////////////////////////
    '/////////////////////////////////////////////////////////////////////////

    Public Sub OnNetworkReachability(ByVal bAvailable As Boolean)
        m_objAccountForm.OnNetworkReachability(bAvailable)
        m_objPhoneForm.OnNetworkReachability(bAvailable)
    End Sub

    Public Sub OnAudioDeviceMicVU(ByVal nLevelVU As Integer)
        m_objPhoneForm.OnAudioDeviceMicVU(nLevelVU)
    End Sub

    Public Sub OnAudioDeviceSpkVU(ByVal nLevelVU As Integer)
        m_objPhoneForm.OnAudioDeviceSpkVU(nLevelVU)
    End Sub

    '/////////////////////////////////////////////////////////////////////////////////////////
    '/////////////////////////////////////////////////////////////////////////////////////////

    Public Sub OnVideoRemoteStarted(ByVal nLineNo As Integer)
        m_objVideoForm.OnVideoRemoteStarted(nLineNo)
    End Sub

    Public Sub OnVideoRemoteEnded(ByVal nLineNo As Integer)
        m_objVideoForm.OnVideoRemoteEnded(nLineNo)
    End Sub

    Public Sub OnVideoRemoteFrameRGB(ByVal nLineNo As Integer, ByVal aFrameRGB As Byte(), ByVal nFrameSize As Integer, ByVal nFrameWidth As Integer, ByVal nFrameHeight As Integer)
        m_objVideoForm.OnVideoRemoteFrameRGB(nLineNo, aFrameRGB, nFrameSize, nFrameWidth, nFrameHeight)
    End Sub

    Public Sub OnVideoDeviceFrameRGB(ByVal nDeviceId As Integer, ByVal aFrameRGB As Byte(), ByVal nFrameSize As Integer, ByVal nFrameWidth As Integer, ByVal nFrameHeight As Integer)
        m_objVideoForm.OnVideoDeviceFrameRGB(nDeviceId, aFrameRGB, nFrameSize, nFrameWidth, nFrameHeight)
    End Sub

    '/////////////////////////////////////////////////////////////////////////////////////////
    '/////////////////////////////////////////////////////////////////////////////////////////

    Public Sub OnConnectingToRegisterREC()
        m_objAccountRecForm.OnConnectingToRegister()
    End Sub

    Public Sub OnTryingToRegisterREC()
        m_objAccountRecForm.OnTryingToRegister()
    End Sub

    Public Sub OnFailToRegisterREC(ByVal nStatusCode As Integer, ByVal sReasonPhrase As String)
        m_objAccountRecForm.OnFailToRegister(nStatusCode, sReasonPhrase)
    End Sub

    Public Sub OnSuccessToRegisterREC()
        m_objAccountRecForm.OnSuccessToRegister()
    End Sub

    '/////////////////////////////////////////////////////////////////////////////////////////
    '/////////////////////////////////////////////////////////////////////////////////////////

    Public Sub OnTryingToReRegisterREC()
        m_objAccountRecForm.OnTryingToReRegister()
    End Sub

    Public Sub OnFailToReRegisterREC(ByVal nStatusCode As Integer, ByVal sReasonPhrase As String)
        m_objAccountRecForm.OnFailToReRegister(nStatusCode, sReasonPhrase)
    End Sub

    Public Sub OnSuccessToReRegisterREC()
        m_objAccountRecForm.OnSuccessToReRegister()
    End Sub

    '/////////////////////////////////////////////////////////////////////////////////////////
    '/////////////////////////////////////////////////////////////////////////////////////////

    Public Sub OnTryingToUnRegisterREC()
        m_objAccountRecForm.OnTryingToUnRegister()
    End Sub

    Public Sub OnFailToUnRegisterREC()
        m_objAccountRecForm.OnFailToUnRegister()
    End Sub

    Public Sub OnSuccessToUnRegisterREC()
        m_objAccountRecForm.OnSuccessToUnRegister()
    End Sub

    '/////////////////////////////////////////////////////////////////////////////////////////
    '/////////////////////////////////////////////////////////////////////////////////////////

    Public Sub OnDialCallStartedREC(ByVal nLineNo As Integer, ByVal sCallerName As String, ByVal sCallerId As String, ByVal sDialNo As String)
        m_objAccountRecForm.OnDialCallStarted(nLineNo, sCallerName, sCallerId, sDialNo)
    End Sub

    Public Sub OnDialingCallREC(ByVal nLineNo As Integer, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String)
        m_objAccountRecForm.OnDialingCall(nLineNo, nStatusCode, sReasonPhrase)
    End Sub

    Public Sub OnConnectedCallREC(ByVal nLineNo As Integer)
        m_objAccountRecForm.OnConnectedCall(nLineNo)
    End Sub

    Public Sub OnDialCallFailedREC(ByVal nLineNo As Integer, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String)
        m_objAccountRecForm.OnDialCallFailed(nLineNo, nStatusCode, sReasonPhrase)
    End Sub

    Public Sub OnHungupCallREC(ByVal nLineNo As Integer)
        m_objAccountRecForm.OnHungupCall(nLineNo)
    End Sub

    '/////////////////////////////////////////////////////////////////////////////////////////
    '/////////////////////////////////////////////////////////////////////////////////////////

    Public Sub OnStatusMsgREC(ByVal nLineNo As Integer, ByVal nErrorCode As Integer, ByVal sErrorMsg As String)
        m_objAccountRecForm.OnStatusMsg(nLineNo, nErrorCode, sErrorMsg)
    End Sub

End Class


