﻿Imports System.Runtime.InteropServices

Partial Public Class PhoneForm

    Private m_bActivateRingTone As Boolean = False

    Private SND_ASYNC As Integer = &H1
    Private SND_NODEFAULT As Integer = &H2
    Private SND_LOOP As Integer = &H8
    Private SND_FILENAME As Integer = &H20000

    <DllImport("winmm.dll")>
    Public Shared Function PlaySound(ByVal lpszName As String, ByVal hModule As Integer, ByVal dwFlags As Integer) As Boolean
    End Function

    '////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////

    Public Sub OnVaxToneOnline()

        m_objVaxUserAgent.BusyRingEnable()

        ActivateDialTone(CheckPlayDialTone.IsChecked)
        ActivateRingTone(CheckPlayRingTone.IsChecked)

    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////

    Public Sub OnRingToneStarted(ByVal sCallId As String)

        If Not m_bActivateRingTone Then
            Return
        End If

        PlaySound("Ring.wav", 0, SND_ASYNC Or SND_FILENAME Or SND_LOOP Or SND_NODEFAULT)

    End Sub

    Public Sub OnRingToneEnded(ByVal sCallId As String)

        If Not m_bActivateRingTone Then
            Return
        End If

        PlaySound(Nothing, 0, 0)

    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////

    Private Sub ActivateRingTone(ByVal bActivate As Boolean)

        m_bActivateRingTone = bActivate

        If Not bActivate Then
            PlaySound(Nothing, 0, 0)
        End If

    End Sub

    Private Sub ActivateDialTone(ByVal bActivate As Boolean)

        If bActivate Then
            m_objVaxUserAgent.DialRingEnable()
        Else
            m_objVaxUserAgent.DialRingDisable()
        End If

    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////

    Private Sub CheckPlayDialTone_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs)
        ActivateDialTone(CheckPlayDialTone.IsChecked.Value)
    End Sub

    Private Sub CheckPlayRingTone_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs)
        ActivateRingTone(CheckPlayRingTone.IsChecked.Value)
    End Sub

End Class
