﻿Imports System

Public Class cVaxSIPUserAgentExCOM
    Inherits cVaxSIPUserAgentCOM

    Public Const VAX_TOTAL_NO_LINES As Integer = 8
    Private Shared m_VaxUserAgent As cVaxSIPUserAgentExCOM = Nothing

    Private m_nActiveAudioInDeviceId As Integer
    Private m_nActiveAudioOutDeviceId As Integer

    Public m_bCaptureSoundDevice As Boolean
    Public m_bActivateVideoDevice As Boolean

    Public m_nVideoDeviceId As Integer
    Public m_nVideoQuality As Integer

    Private m_bEnableREC As Boolean = False
    Private m_bBoostMic As Boolean = False

    Private m_bDetectAMD As Boolean = False
    Private m_nTypeDTMF As Integer = cVaxSIPUserAgentCOM.VAX_DTMF_TYPE_AUTO

    Private Const VAX_ACCOUNT_NAME_PHONE As String = "VaxVoIP-PHONE"
    Private Const VAX_ACCOUNT_NAME_REC As String = "VaxVoIP-REC"

    Public Sub New()

        m_VaxUserAgent = Me

        m_bDetectAMD = False
        m_bEnableREC = False

        m_nActiveAudioInDeviceId = -1
        m_nActiveAudioOutDeviceId = -1

        m_bCaptureSoundDevice = True
        m_bActivateVideoDevice = True

        m_nVideoDeviceId = 0
        m_nVideoQuality = cVaxSIPUserAgentCOM.VAX_VIDEO_QUALITY_MEDIUM

    End Sub

    Public Shared Function GetOBJ() As cVaxSIPUserAgentExCOM
        Return m_VaxUserAgent
    End Function

    '////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////

    Public Overloads Function Initialize(ByVal sDisplayName As String, ByVal sUserName As String, ByVal sAuthLogin As String, ByVal sAuthPwd As String, ByVal sDomainRealm As String, ByVal sServerAddr As String, ByVal nServerPort As Integer, ByVal nServerType As Integer, ByVal bRegisterSIP As Boolean, ByVal bCaptureSoundDevice As Boolean) As Boolean

        MyBase.SetLicenceKey("TRIAL-LICENSE-KEY")
        If Not MyBase.Initialize() Then Return False

        If Not MyBase.AddAccountSIP(VAX_ACCOUNT_NAME_PHONE, nServerType, "", -1, sDisplayName, sUserName, sAuthLogin, sAuthPwd, sDomainRealm, sServerAddr, nServerPort) Then
            MyBase.UnInitialize()
            Return False
        End If

        'MyBase.DiagnosticLogSIP("", True, True)

        OnVaxOnline()
        MyBase.NetworkReachability(True)

        If bRegisterSIP Then
            MyBase.RegisterAccountSIP(VAX_ACCOUNT_NAME_PHONE, 1800)
            MyBase.AutoRegistration(VAX_ACCOUNT_NAME_PHONE, True, -1, 4)
        End If

        m_bCaptureSoundDevice = bCaptureSoundDevice
        MyBase.EnableKeepAlive(VAX_ACCOUNT_NAME_PHONE, 10)

        Return True

    End Function

    '////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////

    Public Overloads Sub UnInitialize()

        MyBase.UnInitialize()
        OnVaxOffline()

    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////

    Public Function GetTotalLine() As Integer
        Return VAX_TOTAL_NO_LINES
    End Function

    '////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////

    Public Overloads Sub DialCallToREC(ByVal nLineNo As Integer)
        If Not m_bEnableREC Then Return

        If Not MyBase.DialCallToREC(VAX_ACCOUNT_NAME_REC, nLineNo, "0000") Then
            OnStatusMsgREC(nLineNo)
            Return
        End If
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////

    Public Function UnRegisterAccountREC() As Boolean

        m_bEnableREC = False
        MyBase.RemoveAccountSIP(VAX_ACCOUNT_NAME_REC)

        Return True

    End Function

    Public Function RegisterAccountREC(ByVal bRegister As Boolean, ByVal sDisplayName As String, ByVal sUserName As String, ByVal sAuthLogin As String, ByVal sAuthPwd As String, ByVal sDomainRealm As String, ByVal sServerAddr As String, ByVal nServerPort As Integer) As Boolean

        m_bEnableREC = False
        MyBase.RemoveAccountSIP(VAX_ACCOUNT_NAME_REC)

        If Not MyBase.AddAccountSIP(VAX_ACCOUNT_NAME_REC, cVaxSIPUserAgentCOM.VAX_ACCOUNT_TYPE_UDP, "", -1, sDisplayName, sUserName, sAuthLogin, sAuthPwd, sDomainRealm, sServerAddr, nServerPort) Then
            Return False
        End If

        If bRegister Then
            If Not MyBase.RegisterAccountSIP(VAX_ACCOUNT_NAME_REC, 1800) Then Return False
        Else
            m_bEnableREC = True
        End If

        Return True

    End Function

    '////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////

    Public Overloads Function DialCall(ByVal nLineNo As Integer, ByVal sCallerName As String, ByVal sCallerId As String, ByVal sDialNo As String) As Boolean

        Dim nInputDeviceId As Integer = m_nActiveAudioInDeviceId
        Dim nOutputDeviceId As Integer = m_nActiveAudioOutDeviceId

        If m_bCaptureSoundDevice = False Then
            nInputDeviceId = cVaxSIPUserAgentCOM.VAX_CAPTURE_SOUND_DEVICE_NONE
            nOutputDeviceId = cVaxSIPUserAgentCOM.VAX_CAPTURE_SOUND_DEVICE_NONE
        End If

        If Not MyBase.DialCall(VAX_ACCOUNT_NAME_PHONE, nLineNo, sCallerName, sCallerId, sDialNo, nInputDeviceId, nOutputDeviceId) Then
            Return False
        End If

        DialCallToREC(nLineNo)
        Return True

    End Function

    '////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////

    Public Overloads Function AcceptCall(ByVal nLineNo As Integer, ByVal sCallId As String) As Boolean

        Dim nInputDeviceId As Integer = m_nActiveAudioInDeviceId
        Dim nOutputDeviceId As Integer = m_nActiveAudioOutDeviceId

        If m_bCaptureSoundDevice = False Then
            nInputDeviceId = cVaxSIPUserAgentCOM.VAX_CAPTURE_SOUND_DEVICE_NONE
            nOutputDeviceId = cVaxSIPUserAgentCOM.VAX_CAPTURE_SOUND_DEVICE_NONE
        End If

        If Not MyBase.AcceptCall(nLineNo, sCallId, nInputDeviceId, nOutputDeviceId) Then
            Return False
        End If

        DialCallToREC(nLineNo)
        Return True

    End Function

    '////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////

    Public Overloads Function DigitDTMF(ByVal nLineNo As Integer, ByVal sDigit As String) As Boolean
        Return MyBase.DigitDTMF(nLineNo, sDigit, m_nTypeDTMF)
    End Function

    Public Sub ForceDigitDTMF(ByVal nTypeDTMF As Integer)
        m_nTypeDTMF = nTypeDTMF
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////

    Public Function IsVolumeBoostMic() As Boolean
        Return m_bBoostMic
    End Function

    '////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////

    Public Function SetVolumeBoostMic(ByVal bEnable As Boolean) As Boolean

        Dim nBoostVol As Integer = 0
        If bEnable Then nBoostVol = 20

        Dim bResult As Boolean = MyBase.SetVolumeMic(nBoostVol)

        If Not bResult Then
            m_bBoostMic = False
        End If

        m_bBoostMic = bEnable
        Return bResult

    End Function

    '////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////

    Public Sub SetActiveAudioInDevice(ByVal nDeviceId As Integer)
        m_nActiveAudioInDeviceId = nDeviceId
    End Sub

    Public Sub SetActiveAudioOutDevice(ByVal nDeviceId As Integer)
        m_nActiveAudioOutDeviceId = nDeviceId
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////

    Public Sub SetActiveVideoDevice(ByVal nDeviceId As Integer)
        m_nVideoDeviceId = nDeviceId
        CaptureVideoDevice()
    End Sub

    Public Sub ActivateVideoDevice(ByVal bActivate As Boolean)
        m_bActivateVideoDevice = bActivate
        CaptureVideoDevice()
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////

    Public Sub SetVideoQuality(ByVal nQuality As Integer)
        m_nVideoQuality = nQuality
        CaptureVideoDevice()
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////

    Private Sub CaptureVideoDevice()

        If GetVideoDevTotal() = 0 Then
            Return
        End If

        CloseVideoDev()

        If Not m_bActivateVideoDevice Then
            Return
        End If

        MyBase.OpenVideoDev(m_nVideoDeviceId, m_nVideoQuality)
        MyBase.VideoCodecBitRate(cVaxSIPUserAgentCOM.VAX_VIDEO_CODEC_VP8, m_nVideoQuality)

    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////

    Public Overloads Sub DetectAMD(ByVal bEnable As Boolean)
        m_bDetectAMD = bEnable
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////

    Public Overloads Sub DialRingEnable()
        MyBase.DialRingEnable("DialRing.wav")
    End Sub

    Public Overloads Sub BusyRingEnable()
        MyBase.BusyRingEnable("BusyRing.wav")
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////

    Public Overloads Function ChatAddContact(ByVal sUserName As String) As Boolean
        Return MyBase.ChatAddContact(VAX_ACCOUNT_NAME_PHONE, sUserName, True)
    End Function

    Public Overloads Function ChatRemoveContact(ByVal sUserName As String) As Boolean
        Return MyBase.ChatRemoveContact(VAX_ACCOUNT_NAME_PHONE, sUserName)
    End Function

    Public Overloads Function ChatSetMyStatus(ByVal nStatusId As Integer) As Boolean
        Return MyBase.ChatSetMyStatus(VAX_ACCOUNT_NAME_PHONE, nStatusId)
    End Function

    Public Overloads Function ChatSendMessageText(ByVal sUserName As String, ByVal sMsgText As String) As Boolean
        Return MyBase.ChatSendMessageText(VAX_ACCOUNT_NAME_PHONE, sUserName, sMsgText, False, 0)
    End Function

    Public Overloads Function ChatSendMessageTyping(ByVal sUserName As String) As Boolean
        Return MyBase.ChatSendMessageTyping(VAX_ACCOUNT_NAME_PHONE, sUserName, 0)
    End Function

    '////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////

    Public Overloads Function BusyLampAddContact(ByVal sUserName As String) As Boolean
        Return MyBase.BusyLampAddContact(VAX_ACCOUNT_NAME_PHONE, sUserName)
    End Function

    Public Overloads Sub BusyLampRemoveContact(ByVal sUserName As String)
        MyBase.BusyLampRemoveContact(VAX_ACCOUNT_NAME_PHONE, sUserName)
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////

    Public Overloads Function RegisterAccountSIP(ByVal nExpire As Integer) As Boolean
        Return MyBase.RegisterAccountSIP(VAX_ACCOUNT_NAME_PHONE, nExpire)
    End Function

    '////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////

    Public Overloads Function AutoRegistration(ByVal bEnable As Boolean, ByVal nTickCountLimit As Integer, ByVal nTickSeconds As Integer) As Boolean
        Return MyBase.AutoRegistration(VAX_ACCOUNT_NAME_PHONE, bEnable, nTickCountLimit, nTickSeconds)
    End Function

    '////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////

    Public Overloads Function EnableKeepAlive(ByVal nSeconds As Integer) As Boolean
        Return MyBase.EnableKeepAlive(VAX_ACCOUNT_NAME_PHONE, nSeconds)
    End Function

    Private Sub OnStatusMsgREC(ByVal nLineNo As Integer)

        Dim nErrorCode As Integer = MyBase.GetVaxErrorCode()
        Dim sErrorMsg As String = MyBase.GetVaxErrorMsg()

        MainForm.m_objMainForm.OnStatusMsgREC(nLineNo, nErrorCode, sErrorMsg)

    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////

    Public Sub OnVaxOnline()
        MainForm.m_objMainForm.OnVaxOnline()
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////

    Public Sub OnVaxOffline()
        MainForm.m_objMainForm.OnVaxOffline()
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////

    Public Overrides Sub OnDigitDTMF(ByVal sAccountName As String, ByVal nLineNo As Integer, ByVal sDigit As String)
        MainForm.m_objMainForm.OnDigitDTMF(nLineNo, sDigit)
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////

    Public Overrides Sub OnPlayWaveDone(ByVal sAccountName As String, ByVal nLineNo As Integer)
        MainForm.m_objMainForm.OnPlayWaveDone(nLineNo)
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////

    Public Overrides Sub OnConnectingToRegister(ByVal sAccountName As String)

        If sAccountName = VAX_ACCOUNT_NAME_REC Then
            MainForm.m_objMainForm.OnConnectingToRegisterREC()
            Return
        End If

        MainForm.m_objMainForm.OnConnectingToRegister()

    End Sub

    Public Overrides Sub OnTryingToRegister(ByVal sAccountName As String)

        If sAccountName = VAX_ACCOUNT_NAME_REC Then
            MainForm.m_objMainForm.OnTryingToRegisterREC()
            Return
        End If

        MainForm.m_objMainForm.OnTryingToRegister()

    End Sub

    Public Overrides Sub OnFailToRegister(ByVal sAccountName As String, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String)

        If sAccountName = VAX_ACCOUNT_NAME_REC Then
            m_bEnableREC = False
            MainForm.m_objMainForm.OnFailToRegisterREC(nStatusCode, sReasonPhrase)
            Return
        End If

        MainForm.m_objMainForm.OnFailToRegister(nStatusCode, sReasonPhrase)
    End Sub

    Public Overrides Sub OnSuccessToRegister(ByVal sAccountName As String)

        If sAccountName = VAX_ACCOUNT_NAME_REC Then
            m_bEnableREC = True
            MainForm.m_objMainForm.OnSuccessToRegisterREC()
            Return
        End If

        MainForm.m_objMainForm.OnSuccessToRegister()

    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////

    Public Overrides Sub OnConnectingToReRegister(ByVal sAccountName As String)
        MainForm.m_objMainForm.OnConnectingToReRegister()
    End Sub

    Public Overrides Sub OnTryingToReRegister(ByVal sAccountName As String)

        If sAccountName = VAX_ACCOUNT_NAME_REC Then
            MainForm.m_objMainForm.OnTryingToReRegisterREC()
            Return
        End If

        MainForm.m_objMainForm.OnTryingToReRegister()

    End Sub

    Public Overrides Sub OnFailToReRegister(ByVal sAccountName As String, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String)

        If sAccountName = VAX_ACCOUNT_NAME_REC Then
            m_bEnableREC = False
            MainForm.m_objMainForm.OnFailToReRegisterREC(nStatusCode, sReasonPhrase)
            Return
        End If

        MainForm.m_objMainForm.OnFailToReRegister(nStatusCode, sReasonPhrase)

    End Sub

    Public Overrides Sub OnSuccessToReRegister(ByVal sAccountName As String)

        If sAccountName = VAX_ACCOUNT_NAME_REC Then
            m_bEnableREC = True
            MainForm.m_objMainForm.OnSuccessToReRegisterREC()
            Return
        End If

        MainForm.m_objMainForm.OnSuccessToReRegister()

    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////

    Public Overrides Sub OnTryingToUnRegister(ByVal sAccountName As String)

        If sAccountName = VAX_ACCOUNT_NAME_REC Then
            MainForm.m_objMainForm.OnTryingToUnRegisterREC()
            Return
        End If

        MainForm.m_objMainForm.OnTryingToUnRegister()

    End Sub

    Public Overrides Sub OnFailToUnRegister(ByVal sAccountName As String)

        If sAccountName = VAX_ACCOUNT_NAME_REC Then
            MainForm.m_objMainForm.OnFailToUnRegisterREC()
            Return
        End If

        MainForm.m_objMainForm.OnFailToUnRegister()

    End Sub

    Public Overrides Sub OnSuccessToUnRegister(ByVal sAccountName As String)

        If sAccountName = VAX_ACCOUNT_NAME_REC Then
            m_bEnableREC = False
            MainForm.m_objMainForm.OnSuccessToUnRegisterREC()
            Return
        End If

        MainForm.m_objMainForm.OnSuccessToUnRegister()

    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////

    Public Overrides Sub OnIncomingCallStarted(ByVal sAccountName As String, ByVal sCallId As String, ByVal sCallerName As String, ByVal sCallerId As String, ByVal sDialNo As String, ByVal sFromURI As String, ByVal sToURI As String)
        MainForm.m_objMainForm.OnIncomingCallStarted(sCallId, sCallerName, sCallerId)
    End Sub

    Public Overrides Sub OnIncomingCallEnded(ByVal sAccountName As String, ByVal sCallId As String, ByVal nReasonCode As Integer)
        MainForm.m_objMainForm.OnIncomingCallEnded(sCallId)
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////

    Public Overrides Sub OnRingToneStarted(ByVal sAccountName As String, ByVal sCallId As String)
        MainForm.m_objMainForm.OnRingToneStarted(sCallId)
    End Sub

    Public Overrides Sub OnRingToneEnded(ByVal sAccountName As String, ByVal sCallId As String)
        MainForm.m_objMainForm.OnRingToneEnded(sCallId)
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////

    Public Overrides Sub OnDialCallStarted(ByVal sAccountName As String, ByVal nLineNo As Integer, ByVal sCallerName As String, ByVal sCallerId As String, ByVal sDialNo As String)

        If sAccountName = VAX_ACCOUNT_NAME_REC Then
            MainForm.m_objMainForm.OnDialCallStartedREC(nLineNo, sCallerName, sCallerId, sDialNo)
            Return
        End If

        MainForm.m_objMainForm.OnDialCallStarted(nLineNo, sCallerName, sCallerId, sDialNo)

    End Sub

    Public Overrides Sub OnDialingCall(ByVal sAccountName As String, ByVal nLineNo As Integer, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String)

        If sAccountName = VAX_ACCOUNT_NAME_REC Then
            MainForm.m_objMainForm.OnDialingCallREC(nLineNo, nStatusCode, sReasonPhrase)
            Return
        End If

        MainForm.m_objMainForm.OnDialingCall(nLineNo, nStatusCode, sReasonPhrase)

    End Sub

    Public Overrides Sub OnDialCallFailed(ByVal sAccountName As String, ByVal nLineNo As Integer, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String, ByVal sContact As String)

        If sAccountName = VAX_ACCOUNT_NAME_REC Then
            MainForm.m_objMainForm.OnDialCallFailedREC(nLineNo, nStatusCode, sReasonPhrase)
            Return
        End If

        MainForm.m_objMainForm.OnDialCallFailed(nLineNo, nStatusCode, sReasonPhrase, sContact)

    End Sub

    Public Overrides Sub OnConnectedCall(ByVal sAccountName As String, ByVal nLineNo As Integer, ByVal sToRTPIP As String, ByVal nToRTPPort As Integer)

        If sAccountName = VAX_ACCOUNT_NAME_REC Then
            MainForm.m_objMainForm.OnConnectedCallREC(nLineNo)
            Return
        End If

        MyBase.DetectAMD(nLineNo, m_bDetectAMD, 6000, 300, 2)
        MainForm.m_objMainForm.OnConnectedCall(nLineNo)

    End Sub

    Public Overrides Sub OnHungupCall(ByVal sAccountName As String, ByVal nLineNo As Integer)

        If sAccountName = VAX_ACCOUNT_NAME_REC Then
            MainForm.m_objMainForm.OnHungupCallREC(nLineNo)
            Return
        End If

        MainForm.m_objMainForm.OnHungupCall(nLineNo)

    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////
    Public Overrides Sub OnSuccessToHold(ByVal sAccountName As String, ByVal nLineNo As Integer)
        MainForm.m_objMainForm.OnSuccessToHold(nLineNo)
    End Sub

    Public Overrides Sub OnTryingToHold(ByVal sAccountName As String, ByVal nLineNo As Integer)
        MainForm.m_objMainForm.OnTryingToHold(nLineNo)
    End Sub

    Public Overrides Sub OnFailToHold(ByVal sAccountName As String, ByVal nLineNo As Integer)
        MainForm.m_objMainForm.OnFailToHold(nLineNo)
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////

    Public Overrides Sub OnSuccessToUnHold(ByVal sAccountName As String, ByVal nLineNo As Integer)
        MainForm.m_objMainForm.OnSuccessToUnHold(nLineNo)
    End Sub

    Public Overrides Sub OnTryingToUnHold(ByVal sAccountName As String, ByVal nLineNo As Integer)
        MainForm.m_objMainForm.OnTryingToUnHold(nLineNo)
    End Sub

    Public Overrides Sub OnFailToUnHold(ByVal sAccountName As String, ByVal nLineNo As Integer)
        MainForm.m_objMainForm.OnFailToUnHold(nLineNo)
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////

    Public Overrides Sub OnTransferCallFailed(ByVal sAccountName As String, ByVal nLineNo As Integer, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String)
        MainForm.m_objMainForm.OnTransferCallFailed(nLineNo, nStatusCode, sReasonPhrase)
    End Sub

    Public Overrides Sub OnTransferCallAccepted(ByVal sAccountName As String, ByVal nLineNo As Integer)
        MainForm.m_objMainForm.OnTransferCallAccepted(nLineNo)
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////

    Public Overrides Sub OnIncomingDiagnostic(ByVal sAccountName As String, ByVal sMsgSIP As String, ByVal sFromIP As String, ByVal nFromPort As Integer)
    End Sub

    Public Overrides Sub OnOutgoingDiagnostic(ByVal sAccountName As String, ByVal sMsgSIP As String, ByVal sToIP As String, ByVal nToPort As Integer)
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////

    Public Overrides Sub OnVoiceMailMsg(ByVal sAccountName As String, ByVal bIsMsgWaiting As Boolean, ByVal nNewMsgCount As Integer, ByVal nOldMsgCount As Integer, ByVal nNewUrgentMsgCount As Integer, ByVal nOldUrgentMsgCount As Integer, ByVal sMsgAccount As String)
        MainForm.m_objMainForm.OnVoiceMailMsg(bIsMsgWaiting, nNewMsgCount, nOldMsgCount, nNewUrgentMsgCount, nOldUrgentMsgCount, sMsgAccount)
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////

    Public Overrides Sub OnChatSubscribeSuccess(ByVal sAccountName As String, ByVal sUserName As String)
        MainForm.m_objMainForm.OnChatSubscribeSuccess(sUserName)
    End Sub

    Public Overrides Sub OnChatSubscribeFailed(ByVal sAccountName As String, ByVal sUserName As String, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String)
        MainForm.m_objMainForm.OnChatSubscribeFailed(sUserName, nStatusCode, sReasonPhrase)
    End Sub

    Public Overrides Sub OnChatContactStatus(ByVal sAccountName As String, ByVal sUserName As String, ByVal nStatusId As Integer)
        MainForm.m_objMainForm.OnChatContactStatus(sUserName, nStatusId)
    End Sub

    Public Overrides Sub OnChatSendMsgTextSuccess(ByVal sAccountName As String, ByVal sUserName As String, ByVal sMsgText As String, ByVal nUserValue As Long)
        MainForm.m_objMainForm.OnChatSendMsgTextSuccess(sUserName, sMsgText, nUserValue)
    End Sub

    Public Overrides Sub OnChatSendMsgTextFailed(ByVal sAccountName As String, ByVal sUserName As String, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String, ByVal sMsgText As String, ByVal nUserValue As Long)
        MainForm.m_objMainForm.OnChatSendMsgTextFailed(sUserName, nStatusCode, sReasonPhrase, sMsgText, nUserValue)
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////

    Public Overrides Sub OnChatSendMsgTypingSuccess(ByVal sAccountName As String, ByVal sUserName As String, ByVal nUserValue As Long)
        MainForm.m_objMainForm.OnChatSendMsgTypingSuccess(sUserName, nUserValue)
    End Sub

    Public Overrides Sub OnChatSendMsgTypingFailed(ByVal sAccountName As String, ByVal sUserName As String, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String, ByVal nUserValue As Long)
        MainForm.m_objMainForm.OnChatSendMsgTypingFailed(sUserName, nStatusCode, sReasonPhrase, nUserValue)
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////

    Public Overrides Sub OnChatRecvMsgText(ByVal sAccountName As String, ByVal sUserName As String, ByVal sMsgText As String, ByVal bIsChatContact As Boolean)
        MainForm.m_objMainForm.OnChatRecvMsgText(sUserName, sMsgText, bIsChatContact)
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////

    Public Overrides Sub OnChatRecvMsgTypingStart(ByVal sAccountName As String, ByVal sUserName As String)
        MainForm.m_objMainForm.OnChatRecvMsgTypingStart(sUserName)
    End Sub

    Public Overrides Sub OnChatRecvMsgTypingStop(ByVal sAccountName As String, ByVal sUserName As String)
        MainForm.m_objMainForm.OnChatRecvMsgTypingStop(sUserName)
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////

    Public Overrides Sub OnDetectedAMD(ByVal sAccountName As String, ByVal nLineNo As Integer, ByVal bIsHuman As Boolean)
        MainForm.m_objMainForm.OnDetectedAMD(nLineNo, bIsHuman)
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////

    Public Overrides Sub OnBusyLampSubscribeSuccess(ByVal sAccountName As String, ByVal sUserName As String)
        MainForm.m_objMainForm.OnBusyLampSubscribeSuccess(sUserName)
    End Sub

    Public Overrides Sub OnBusyLampSubscribeFailed(ByVal sAccountName As String, ByVal sUserName As String, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String)
        MainForm.m_objMainForm.OnBusyLampSubscribeFailed(sUserName, nStatusCode, sReasonPhrase)
    End Sub

    Public Overrides Sub OnBusyLampContactStatus(ByVal sAccountName As String, ByVal sUserName As String, ByVal nStatusId As Integer)
        MainForm.m_objMainForm.OnBusyLampContactStatus(sUserName, nStatusId)
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////

    Public Overrides Sub OnVideoRemoteStarted(ByVal sAccountName As String, ByVal nLineNo As Integer)
        MainForm.m_objMainForm.OnVideoRemoteStarted(nLineNo)
    End Sub

    Public Overrides Sub OnVideoRemoteEnded(ByVal sAccountName As String, ByVal nLineNo As Integer)
        MainForm.m_objMainForm.OnVideoRemoteEnded(nLineNo)
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////

    Public Overrides Sub OnVideoRemoteFrameRGB(ByVal sAccountName As String, ByVal nLineNo As Integer, ByVal aFrameRGB As Byte(), ByVal nFrameSize As Integer, ByVal nFrameWidth As Integer, ByVal nFrameHeight As Integer)
        MainForm.m_objMainForm.OnVideoRemoteFrameRGB(nLineNo, aFrameRGB, nFrameSize, nFrameWidth, nFrameHeight)
    End Sub

    Public Overrides Sub OnVideoDeviceFrameRGB(ByVal nDeviceId As Integer, ByVal aFrameRGB As Byte(), ByVal nFrameSize As Integer, ByVal nFrameWidth As Integer, ByVal nFrameHeight As Integer)
        MainForm.m_objMainForm.OnVideoDeviceFrameRGB(nDeviceId, aFrameRGB, nFrameSize, nFrameWidth, nFrameHeight)
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////

    Public Overrides Sub OnAudioDeviceMicVU(ByVal nLevelVU As Integer)
        MainForm.m_objMainForm.OnAudioDeviceMicVU(nLevelVU)
    End Sub

    Public Overrides Sub OnAudioDeviceSpkVU(ByVal nLevelVU As Integer)
        MainForm.m_objMainForm.OnAudioDeviceSpkVU(nLevelVU)
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////

    Public Overrides Sub OnNetworkReachability(ByVal bAvailable As Boolean)
        MainForm.m_objMainForm.OnNetworkReachability(bAvailable)
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////

    Public Overrides Sub OnVaxErrorMsg(ByVal sFuncName As String, ByVal sErrorMsg As String, ByVal nErrorCode As Integer)

        If sFuncName = "DialRingEnable" Then
            MessageBox.Show("Unable to access or find DialRing.wav file", "VaxVoIP SIP SDK", MessageBoxButton.OK, MessageBoxImage.Exclamation)
            Return
        End If

        If sFuncName = "BusyRingEnable" Then
            MessageBox.Show("Unable to access or find BusyRing.wav file", "VaxVoIP SIP SDK", MessageBoxButton.OK, MessageBoxImage.Exclamation)
            Return
        End If

        If sFuncName = "OpenLineREC" OrElse sFuncName = "DialCallToREC" Then
            Return
        End If

        MessageBox.Show(sErrorMsg, "VaxVoIP SIP SDK", MessageBoxButton.OK, MessageBoxImage.Exclamation)

    End Sub

End Class
